package com.moyoung.moyoung_ble_plugin.event;

import android.os.Handler;
import android.os.Looper;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.bean.CRPDrinkWaterPeriodInfo;
import com.crrepa.ble.conn.bean.CRPNewDrinkWaterPeriodInfo;
import com.crrepa.ble.conn.bean.CRPWaterIntakeInfo;
import com.crrepa.ble.conn.listener.CRPDeviceDrinkWaterListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnectionEventChannelHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;

import java.util.List;

import io.flutter.plugin.common.MethodCall;

public class DrinkWaterHandler extends BaseConnectionEventChannelHandler {

    private static final DrinkWaterHandler instance = new DrinkWaterHandler();
    public static DrinkWaterHandler getInstance() {
        return instance;
    }

    @Override
    public void setConnListener(CRPBleConnection connection, MethodCall call) {
        connection.setDrinkWaterListener(new CRPDeviceDrinkWaterListener() {
            @Override
            public void onDrinkWaterPeriod(CRPDrinkWaterPeriodInfo drinkWaterPeriodInfo) {
                if (eventSink == null) {
                    return;
                }
                String drinkWaterPeriod = GsonUtils.get().toJson(drinkWaterPeriodInfo, CRPDrinkWaterPeriodInfo.class);
                new Handler(Looper.getMainLooper()).post(() -> eventSink.success(drinkWaterPeriod));
            }

            @Override
            public void onNewDrinkWaterPeriod(CRPNewDrinkWaterPeriodInfo newDrinkWaterPeriodInfo) {

            }

            @Override
            public void onDrinkWaterGoals(int i) {

            }

            @Override
            public void onTodayWaterIntake(int i) {

            }

            @Override
            public void onWaterIntakeChange(CRPWaterIntakeInfo waterIntakeInfo) {

            }

            @Override
            public void onDeleteWaterIntake(CRPWaterIntakeInfo.WaterIntakeType waterIntakeType, int i) {

            }

            @Override
            public void onTodayWaterIntakeHistoryChange(List<CRPWaterIntakeInfo> list) {

            }

            @Override
            public void requestWaterIntakeHistory() {

            }
        });
    }
}
